
//init the xmlhttprequest object
function loadXMLDoc(url, xmlhttp, func) 
{
        xmlhttp.onreadystatechange = function () {};
        xmlhttp.abort();
        xmlhttp.onreadystatechange = func;
        xmlhttp.open("POST", url, true);
}

function createXMLHttpObject()
{
        try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {}
        try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) {}
        try { return new XMLHttpRequest(); } catch(e) {}
        return null;
}

function switch_iprouting()
{
        lastaction = "NicIpRouting";
        valuearray = new Array();
        if (document.getElementById("IPRouting").value=="Enabled")
        {
                document.getElementById("IPRouting").value="Disabled";
                valuearray[0] = "0";
        }
        else
        {
                document.getElementById("IPRouting").value="Enabled";
                valuearray[0] = "1";
        }
        query("NicIpRouting", new Array("Enabled"), valuearray);        
}

function apply()
{
        close_open_fields();
        valuearray = new Array();
        sendnamearray = new Array();
        if (extramethods=="PlcAddFav")
        {
                sendnamearray = new Array("Path","Group");
                var groupname = document.getElementById("GroupName").value;
                if (groupname=="")
                {
                        alert("You have to enter a Groupname.");
                        return;
                }
                
                valuearray[0] = "";
                valuearray[1] = groupname;       
        }   
        else if (extramethods=="FwAddRule")
        {
                var desc = document.getElementById("fwDescription").value;
                if (desc=="")
                {
                        alert("You have to enter a Description.");
                        return;
                }
                sendnamearray = new Array("Type","PortMin","PortMax","Protocol","IpAddress","IpMask","Active","Description");

                var type=0;
                for (var i=0; i<document.getElementById("fwType").options.length; i++)
                {
                        if (document.getElementById("fwType").options[i].selected)
                                type+=document.getElementById("fwType").options[i].value;
                }
                valuearray[0] = type;
                valuearray[1] = document.getElementById("fwPortMin").value;
                valuearray[2] = document.getElementById("fwPortMax").value;
                valuearray[3] = document.getElementById("fwProtocol").value;
                valuearray[4] = document.getElementById("fwIpAddress").value;
                valuearray[5] = document.getElementById("fwIpMask").value;
                valuearray[6] = ((document.getElementById("fwActive").checked) ? "1" : "0");
                valuearray[7] = desc;
                
        }
        else if (extramethods=="UserAdd")
        {
                sendnamearray = new Array("UserName","FtpEnabled","RasEnabled","SmbEnabled","Password");
                var username = document.getElementById("UserName").value;
                if (username=="")
                {
                        alert("You have to enter a Username.");
                        return;
                }                

                
                valuearray[0] = username;
                var enabled = ((document.getElementById("EnableFTP").checked) ? "1" : "0");
                valuearray[1] = enabled;
                enabled = ((document.getElementById("EnableRAS").checked) ? "1" : "0");
                valuearray[2] = enabled;
                enabled = ((document.getElementById("EnableSMB").checked) ? "1" : "0");
                valuearray[3] = enabled;
                
                
                valuearray[4] = document.getElementById("Password").value;
        }
        else if (extramethods=="TcAddRoute")
        {       
                sendnamearray = new Array("Name","Address","AmsAddress","Flags","Timeout","Transport");
                var name = document.getElementById("AddName").value;
                var addr = document.getElementById("AddAddress").value;
                var ams = document.getElementById("AddAmsAddress").value;
                if (name=="" || addr=="" || ams=="")
                {
                        alert("You have to enter a Name, an Address and an Ams Net Id.");
                        return;
                }
                valuearray[0] = name;
                valuearray[1] = addr;
                valuearray[2] = ams;
                var flags;
               
                if (document.getElementById("tem").value && document.getElementById("dyn").value) flags=7;
                else if (document.getElementById("tem").value) flags=5;
                else if (document.getElementById("dyn").value) flags=6;
                else flags = 4;
                
                valuearray[3] = flags;
                valuearray[4] = document.getElementById("AddTimeout").value;
                valuearray[5] = document.getElementById("AddTransport").value;
        }
        else if (extramethods=="ShareAdd")
        {
                sendnamearray = new Array("Name","Directory");
                var name = document.getElementById("Name").value;
                var dir;
                try
                {
                        dir = document.getElementById("Directory").value;
                }
                catch (e)
                {
                        alert("You have choose a Directory.");
                        return;
                }
                if (name=="" || dir =="")
                {
                        alert("You have to enter a Name and a Directory.");
                        return;
                }
                valuearray[0] = name;
                valuearray[1] = dir;                 
        }
        else if (extramethods=="CustomerSetNamedOption")
        {
                sendnamearray = new Array("Option","Value");
                var option = document.getElementById("Option").value;
                var value = document.getElementById("Value").value;
                if (option=="")
                {
                        alert("You have to enter a Name.");
                        return;
                } 
                if (value=="")   
                {
                        alert("You have to enter a Value.");
                        return;
                }
                valuearray[0] = option;
                valuearray[1] = value;
        }
        else
        {
                k=0;
                for (var i = 0; i < params.length; i++) 
                {
                        try
                        {
                                value = document.getElementById(params[i].name).firstChild.innerHTML; 
                        } catch (e){}
        
                        switch (params[i].type)
                        {
                                case "yn":
                                        if (value=="Yes")
                                                value=1;
                                        else value=0;
                                        break;
                                case "tf":             
                                        if (value=="True")
                                                value = 1;
                                        else value = 0;      
                                        break;
                                case "ed":
                                        if (value=="Enabled")
                                                value = 1;
                                        else value = 0;      
                                        break;
                                case "security":
                                        if (value=="Disabled (0)")
                                                value = 0;
                                        else if (value=="Webpage (1)")
                                                value = 1;
                                        else value = 2;
                                        break;
                                case "days":
                                        value = value.split(' ');
                                        value = value[0];
                                        value = value*1000*60*60*24;
                                        break;
                                case "rf": //not editable
                                        break;
                                case "GetIpFrom1":
                                        value = document.getElementById(params[i+1].name).firstChild.innerHTML;
                                        if (value == "Dhcp")
                                               value=1;
                                        else value=0;
                                        break; 
                                case "GetIpFrom2":
                                        if (value=="AutoIp Pool")
                                                value = 1;
                                        else value = 0;
                                        break;
                                 case "tz":
                                        for (var j = 0; j < currenttemp.length; j++)
                                        {
                                                if (currenttemp[j]==value)
                                                {
                                                        value = j;
                                                        break;
                                                }
                                
                                        }
                                        break;
                                 default:
                                        break;                                                       
                        }
                        if (params[i].send=="1")
                        {
                                valuearray[k] = value;
                                sendnamearray[k] = params[i].name;
                                k++;
                                
                                if (showdebug) document.getElementById("debug").innerHTML += params[i].name+" "+value+"<br>";
                        }
                }
        }
        
        if (extramethods=="NicSetSettings")
        {
                  valuearray[0] = document.getElementById("sel").selectedIndex;    
        }
        lastaction = extramethods;
        query(lastaction, sendnamearray, valuearray);
}

function reset_open() /* ie6 onblur workaround */
{
        for (var i=0; i < 255; i++)
        {
                is_open[i]=false;
        }
}

function close_open_fields()
{
        for (var j=0; j < 20; j++) /* ie6 onblur workaround */
        {
                if (is_open[j])
                {
                        edit_leave(j, is_open[j]);
                }
        }
}


function edit(i, value)
{
        var oldvalue = value;
        
        close_open_fields();
        is_open[i] = value;
        
        var elem = document.getElementById(params[i].name);
        if (value.toLowerCase()=="<i>-</i>")
                value="";
                
        if (params[i].name == "LogSize" && value < 4096)
                value = 4096;
                
        if (params[i].name == "LogFile" && value == "")
                value = "\\Hard Disk";
                
        text="";
        switch (params[i].type)
        {
                case "yn":
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.options[this.options.selectedIndex].text)\"><option value=\"1\"";
                        if (value=="Yes")
                                text += "selected";
                        text += ">Yes</option><option value=\"0\"";
                        if (value=="No")
                                text += "selected";
                        text += ">No</option></select>";
                        break;
                case "boolean":
                case "tf":
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.options[this.options.selectedIndex].text)\"><option value=\"1\"";
                        if (value=="True")
                                text += "selected";
                        text += ">True</option><option value=\"0\"";
                        if (value=="False")
                                text += "selected";
                        text += ">False</option></select>";      
                        break;
                case "ed":
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.options[this.options.selectedIndex].text)\"><option value=\"1\"";
                        if (value=="Enabled")
                                text += "selected";
                        text += ">Enabled</option><option value=\"0\"";
                        if (value=="Disabled")
                                text += "selected";
                        text += ">Disabled</option></select>";      
                        break;
                case "rf": //not editable
                        break
                case "security":                                     
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.options[this.options.selectedIndex].text)\"><option value=\"0\"";
                        if (value=="Disabled (0)")
                                text += "selected";
                        text += ">Disabled (0)</option><option value=\"1\"";
                        if (value=="Webpage (1)")
                                text += "selected";
                        text += ">Webpage (1)</option><option value=\"2\"";
                        if (value=="Device (2)")
                                text += "selected";
                        text += ">Device (2)</option></select>"; 
                        break; 
                case "days":
                        text = create_selectbox(1,32,""," days",value,i,false);
                        break;
                case "tz":
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.value)\">";
                        for (var j = 0; j < currenttemp.length; j++)
                        {
                                text+="<option value=\""+currenttemp[j]+"\"";
                                if (currenttemp[j]==value)
                                        text+="selected";
                                text+=">"+currenttemp[j]+"</option>"; 
                        }
                        text += "</select>";
                        break;
                case "GetIpFrom1":
                case "GetIpFrom2":
                        text = "<select class=\"input\" onchange=\"edit_leave('"+i+"', this.value)\"><option value=\"Dhcp\"";
                        if (value=="Dhcp")
                                text += "selected";
                        text += ">Dhcp</option><option value=\"AutoIp Pool\"";
                        if (value=="AutoIp Pool")
                                text += "selected";
                        text += ">AutoIp Pool</option><option value=\"StaticIp Pool\"";
                        if (value=="StaticIp Pool")
                                text += "selected";
                        text += ">StaticIp Pool</option></select>";
                        break;
                 case "Time":
                        timearr = value.split(":");
                        text = create_selectbox(0,23,"timeHour","",timearr[0],-1,true) + " ";
                        text += create_selectbox(0,59,"timeMinute","",timearr[1],-1,true) + " ";
                        text += create_selectbox(0,59,"timeSecond","",timearr[2],-1,true) + " ";                        
                        text += "<input class=\"button\" type=\"submit\" onclick=\"time_leave('"+i+"')\" value=\"Change\">";
                        break;
                 case "Date":
                        text += date_picker_refresh(value, i, oldvalue);
                        break;
                 case "Folder":
                        text = "<input id=\"selectedfolder\" class=\"input\" type=\"text\" style=\"width:98%;\" value=\""+value+"\"><br><div id=\"subfolders\">loading subfolders...</div>";
                        text += "<input class=\"button\" type=\"submit\" onclick=\"folder_leave('"+i+"')\" value=\"Ok\">";
                        //onblur=\"edit_leave('"+i+"', this.value)\
                        one_arg_query("MiscGetSubFolders", "Folder", value);
                        break;
                 default:
                        text = "<input class=\"input\" type=\"text\" style=\"width:98%;\" onblur=\"edit_leave('"+i+"', this.value)\" value=\""+value+"\">";
                        break;                                                     
        }
        elem.innerHTML=text;
        
        elem.firstChild.focus();
        elem.firstChild.focus();
}

function edit_leave(i, value)
{
        is_open[i] = false;
        oldvalue = document.getElementById(params[i].name+"old").value;

        for (var j = 0; j<params.length; j++)
        {
                if (params[j].lock.indexOf("locked:"+params[i].name)==0)
                {
                        if (is_true(value))
                        {
                                document.getElementById(params[j].name+"td").className = "lockedtable";
                                document.getElementById(params[j].name).innerHTML = "<span style=\"width:100%; display: block;\">"+document.getElementById(params[j].name).firstChild.innerHTML+"</span>";
                        }
                        else
                        {
                                document.getElementById(params[j].name+"td").className = "normaltable";
                                document.getElementById(params[j].name).innerHTML = "<span style=\"width:100%; display: block;\" onclick=\"edit('"+j+"',this.innerHTML)\">"+document.getElementById(params[j].name).firstChild.innerHTML+"</span>";
                        }
                }
        }
                      
        if (value=="")
                value="<i>-</i>";
                
        if (value!=oldvalue)
        {
                document.getElementById(params[i].name+"info").style.display = "";
                document.getElementById("apply").disabled=false;
                document.getElementById("apply").className="button";
        }
        else    document.getElementById(params[i].name+"info").style.display = "none";
        
        document.getElementById(params[i].name).innerHTML = "<span style=\"width:100%; display: block;\" onclick=\"edit('"+i+"',this.innerHTML)\">"+value+"</span>";
}

function change_disp_mode(value)
{
        if (confirm("Change display Mode?"))
        {
                one_arg_query("DispSetMode", "Index", value);
        }
}

function one_arg_query(method, name, value)
{
        if (value!="" || method=="MiscGetSubFolders" || method=="PlcGetSymbols")
        {
                names = new Array (name);
                values = new Array (value);
                lastaction = method;
                query(method, names, values);
        }
}

function two_arg_query(method, name, value, name2, value2)
{
        if (value!="")
        {
                names = new Array (name, name2);
                values = new Array (value, value2);
                lastaction = method;
                query(method, names, values);
        }
}

function input_query(method, name2, inputtitle, changelastaction, value, name)
{
        var value2 = prompt(inputtitle, "");
        if (name2!="" && value2!=null)
        {
                if (name!="")
                {
                        names = new Array (name, name2);
                        values = new Array (value, value2);
                }
                else
                {
                        names = new Array (name2);
                        values = new Array (value2);
                }
                if(changelastaction)
                        lastaction = method;
                query(method, names, values);
        }  
}

//sends SOAP request
function load_page(page)
{
        load_page(page,new Array(0),new Array(0));
}


function load_page(page, names, values)
{
        if (loop=="reboot") return;
       
        
        document.getElementById("infoadd").innerHTML = "";
        loop="none";
        if (showdebug) document.getElementById("debug").innerHTML += "load_page "+page+"<br>";

        var dontchangemenu=false;
        try
        {
                document.getElementById(page).style.fontWeight="bold";
        }
        catch (e){dontchangemenu=true;}
        
        
        
        if (lastmenu!=page && !dontchangemenu)
        {
                try
                {
                        document.getElementById(lastmenu).style.fontWeight="normal";
                        lastmenu = page;                
                }
                catch (e){}
        }
        lastaction = page;
        
        if (page=="MisscShowPages")
        {
                query("MiscShowPages",names,values);
        }
        if (page=="DeviceName")
        {
                query("SysGetInfo",names,values);
        }
        else if (page=="Overview" || page == "Reboot" || page=="ReloadNeeded" || page=="FactorySettings" || page=="Software" || page=="TcLog" || page=="Print" || page == "ListSymbols" || (page.indexOf("CustomerPage")==0))
        {
            if (loop!="reboot")
            {
                init_show();
                type=page;
                show();
            }
        }
        else if (page=="doReboot")
        {
                doReboot(true,true);
        }
        else if  (page=="doReset")
        {
                doReset(true);
        }
        else
        {
                query(page,names,values)        
        }    
}

function query(method,names,values)
{
        query_full(req,processReqChange,method,names,values);
}
function query_full(req,func,method,names,values)
{   
    if (showdebug) document.getElementById("debug").innerHTML += "query "+method+"<br>";

    var sr =
        "<?xml version=\"1.0\" encoding=\"utf-8\"?>" + 
        "<s:Envelope s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\" xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
        "<s:Body><u:"+method+" xmlns:u=\"urn:beckhoff.com:service:cxconfig:1\">";
        
        if (names)
        {
                for (var i=0; i<names.length; i++)
                {
                        if (names[i]!="Error" && names[i][0]!="-")
                                sr+="<"+names[i]+">"+values[i]+"</"+names[i]+">";
                }
        }                    
    sr+="</u:"+method+"></s:Body></s:Envelope>";

    loadXMLDoc(device_url, req, func);
    
    try
    {
            req.setRequestHeader("SOAPAction", "urn:beckhoff.com:service:cxconfig:1#"+method);
            req.setRequestHeader("Content-Type", "text/xml; charset=utf-8");
            req.setRequestHeader("Content-Length", sr.length);
            req.setRequestHeader("Expect", "100-continue");
            req.setRequestHeader("Connection", "Keep-Alive");
    }
    catch (e) //object is in use, try later
    {
        window.setTimeout(query_full, 200, req, func, method, names, values);
        return;
    }
    req.send(sr);
   
}

var success, errors, req, device_url;

//declares variables, starts loop
function init()
{
        is_open = new Array();
        reset_open();
        lastaction="";
        lastmenu="";
        addtext=new Array();
        addtexttimer= new Array();
        addtextcolor= new Array();
        pageaddtext = "";
        valuearray="";
        success = 0;
        errors = 0;
        device_name="";
        showdebug = false;
        rebootcount = 0;
        reboottrials = 0;
        loop = "none"
        reboottext = "";
        init_show();
               
        try
        {
                device_url = "/upnpisapi?uuid:"+deviceid+"+urn:beckhoff.com:serviceId:cxconfig";
        }
        catch (e)
        {
                showerror("Unable to Init Device");
        }
        req = createXMLHttpObject();
        req_loop = createXMLHttpObject();
        
        if (showdebug)
                document.getElementById("debug").innerHTML += "init done<br>";      
        
        load_page("MiscShowPages");
}

function init_show()
{
        addinfo="";
        showcontent=true;
        listoptions=null;
        currenttemp=null;
        params=new Array();
        editmethod=new Array();
        editdisplay=new Array();
        extramethods="";
        extramethoddisplay="Apply";
        extramethodinput = "";
        doadd=false;
        addquery="";
        triggersavealert=false;
        pageaddtext = "";
        
        for (var i=addtexttimer.length-1; i >=0; i--)
        {
                if (addtexttimer[i]<=0)
                {
                        remove_text(i);
                }
                else addtexttimer[i]--;
        }        
        title="";
        type="";
}

function complete_init() //called after getting the devicename
{        
        if (document.is_ie)
        {
                try 
                {
                        document.frames['ajaxnav'].getLocation();
                }
                catch (e)
                {
                        document.is_ie = false;
                }
        }

        lastaction="Overview";
        lastmenu="Overview";
        if(document.is_ie)
        {
                fix = new AjaxIframesFixer(); 
        }
        else
                fix = new AjaxUrlFixer();
        
}

function processPlcReqChange() 
{
        if (plcreq.readyState == 4)
        {
                document.plc_in_use = false;

                if (plcreq.status == 200 || plcreq.status == 304)
                {                        
                        response = plcreq.responseXML.documentElement; //XML data returned from server                   
                        var data;
                        try
                        {
                            var prefix = "";
                            if (document.is_ie)
                            {
                                prefix = "ns1:";
                            }
                            response.getElementsByTagName(prefix+'WriteResponse')[0].firstChild.data;
                            mode = "write";
                        }
                        catch (e)
                        {
                            mode = "read";
                        }
                        
                        if (mode=="read")
                        {                         
                                var prefix = "";
                                var prefix2 = "";
                                if (document.is_ie==true)
                                {
                                        prefix="ns1:";
                                }
                                        
                                var x = 0;
                                var y = 0;
                                while (true)
                                {
                                        try
                                        {
                                                xmldata = response.getElementsByTagName(prefix+'Items')[x];
                                        }
                                        catch (e)
                                        {
                                                break;
                                        }
                                        if (xmldata==null)
                                                break;
                                        var name = xmldata.getAttribute('ItemName');
                                        var type = "";
                                        var value = "";
                                        try
                                        {
                                                value = xmldata.getAttribute('ResultID');
                                         }
                                        catch (e)
                                        {
                                                value = "";
                                        }
                                        
                                        
                                        if (value=="" || value==null)
                                        {
                                                try
                                                {
                                                        var temp = response.getElementsByTagName(prefix+'Value')[y];
                                                        y++;
                                                        value=temp.firstChild.data;
                                                        type=temp.getAttribute(prefix2+'xsi:type');
                                                        type = type.substr(4,type.length-4);
                                                }
                                                catch (e)
                                                {}
                                                
                                                if (type=="boolean" && is_true(value))
                                                        document.getElementById("plcvalue_"+name).style.color = "blue";
                                                else document.getElementById("plcvalue_"+name).style.color = "";
                                        }
                                        try
                                        {
                                                if (!document.getElementById("plcedit_"+name) || document.getElementById("plcedit_"+name).innerHTML == "")
                                                {
                                                        document.getElementById("plcvalue_"+name).innerHTML = value;
                                                        document.getElementById("plctype_"+name).innerHTML = type;
                                                }                                                
                                        }
                                        catch (e)
                                        {
                                                return;
                                        }
                                        x++;
                                }
                        }  
                }
        }
}

function processCustomerReqChange()
{
        if (creq.readyState == 4)
        {
                if (creq.status == 200 || creq.status == 304) //304 for opera
                {
                        var cresponse = creq.responseXML.documentElement;
                        var name, url;
                        var error = false;
                        var i = 0;
                        
                                               
                        while (!error)
                        {
                                try
                                {       
                                        if (document.is_ie)
                                                var table = document.getElementById("customertable").getElementsByTagName("TBODY")[0];
                                        else var table = document.getElementById("customertable");
                                        name = cresponse.getElementsByTagName("Name")[i].firstChild.data;
                                        url = cresponse.getElementsByTagName("URL")[i].firstChild.data;
                                        title = cresponse.getElementsByTagName("ShowTitle")[i].firstChild.data;
                                        
                                        
                                        var img = document.createElement('img');
                                        img.setAttribute("src", "images/LU.gif");
                                        img.setAttribute("width", "95");
                                        img.setAttribute("height", "16");
                                        img.setAttribute("border", "0");
                                        
                                        var img2 = document.createElement('img');
                                        img2.setAttribute("src", "images/SE.gif");
                                        img2.setAttribute("border", "0");
                                        
                                        var a = document.createElement('a');
                                        var link = "index.htm#CustomerPage"+i;
                                        link=fixLink(link);  
                                        a.setAttribute("href", link);
                                        a.setAttribute("id", "CustomerPage"+i);
                                        a.innerHTML = name;
                                        
                                        var td1 = document.createElement("TD")
             
                                        td1.appendChild(img);
                                        td1.appendChild(img2);

                                        var td2 = document.createElement("TD");
                                        td2.appendChild(a);
                                        
                                        var row = document.createElement("TR")
                                        row.appendChild(td1);
                                        row.appendChild(td2);
                                        document.getElementById("customertable").appendChild(row);
                                        
                                        try
                                        {
                                                table.appendChild(row); //for IE
                                        }
                                        catch (e){}
                                        
                                        customerpages[i]=url;
                                        
                                        if (title=="1")
                                                customerpagetitle[i]=name;
                                        else customerpagetitle[i]="";
                                        i++;
                                }
                                catch (e){error = true;}
                        }
                        creq = null;
                }
        }
}

function processLoopReqChange()
{
        if (req_loop.readyState == 4)
        {
                // only if "OK"
                if (req_loop.status == 200)
                {
                        if (showdebug) document.getElementById("debug").innerHTML += "looping<br>";
                        response = req_loop.responseXML.documentElement;
                        if (loop=="reboot")
                        {
                              try
                              {
                                        var state = response.getElementsByTagName("State")[0].firstChild.data;
                                        
                                        if (reboottrials > 3)
                                        {
                                                loop="none";
                                                document.getElementById("mainmenu").style.display="";
                                                document.getElementById("topmenu").style.display="";
                                                reboottrials=0;
                                                lastaction=beforeboot;
                                                req = createXMLHttpObject();
                                                load_page(beforeboot);
                                        }
                                        else reboottrials++;
                                        return;
                              }
                              catch (e) {}                                          
                        }
                        else if (loop=="state")
                        {
                              if (lastaction=="TcGetInfo")
                              {
                                      try
                                      {
                                                var state = response.getElementsByTagName("State")[0].firstChild.data;
                                                document.getElementById("-statetd").className=state;
                                                document.getElementById("-statetd").innerHTML=state;
                                      }
                                      catch (e) {}
                              } 
                              else 
                              {
                                loop="none"
                              }   
                        }
                        else if (loop=="memory")
                        {
                              if (lastaction=="SysGetInfo" || lastaction=="SysSetMemDivision")
                              {
                                      try
                                      {
                                                var used = response.getElementsByTagName("Used")[0].firstChild.data;
                                                var total = response.getElementsByTagName("Total")[0].firstChild.data;
                                                var sused = response.getElementsByTagName("sUsed")[0].firstChild.data;
                                                var stotal = response.getElementsByTagName("sTotal")[0].firstChild.data;
                                                var per = response.getElementsByTagName("sPercent")[0].firstChild.data;
                                                var cpu = response.getElementsByTagName("CpuUsage")[0].firstChild.data;;
                                                var mp = Math.ceil(((used/total)*100)*((100-per)/100));
                                                var sp = Math.ceil((((stotal-sused)/stotal)*100)*(per/100));
                                                
                                                
                                                pic = "";
                                                pic += "<img src=\"images/unused.gif\" height=\"12\" width=\""+3*sp+"\">";
                                                
   
                                                if (document.images)
                                                {
                                                        pre_bar = new Image();
                                                        pre_sli = new Image();
                                                        pre_unu = new Image();
                                                        pre_bar.src = "images/bar.gif";
                                                        pre_sli.src = "images/slider.gif";
                                                        pre_unu.src = "images/unused.gif";
                                                }

                                                
                                                for (var i = 1; i < per-sp+1; i++)
                                                {
                                                        pic += "<a href=\"javascript:one_arg_query('SysSetMemDivision', 'Percent', '"+i+"')\"><img alt=\""+i+"%\" src=\"images/bar.gif\" height=\"12\" width=\"3\" border=0></a>";
                                                }
                                                pic += "<img alt=\""+per+"%\" src=\"images/slider.gif\" height=\"12\" width=\"4\">";
                                                for (var i = 2; i < (100-per-mp); i++)
                                                {
                                                        pic += "<a href=\"javascript:one_arg_query('SysSetMemDivision', 'Percent', '"+(per-sp+i)+"')\"><img alt=\""+(per-sp+i)+"%\" src=\"images/bar.gif\" height=\"12\" width=\"3\" border=0></a>";
                                                }
                                                pic += "<img src=\"images/unused.gif\" height=\"12\" width=\""+3*mp+"\">";

                                                
                                                
                                                /*
                                                pic = "<img src=\"images/unused.jpg\" height=\"12\" width=\""+sp*3+"\">";
                                                pic += "<img src=\"images/bar.jpg\" height=\"12\" width=\""+(per-sp)*3+"\">";
                                                pic += "<img src=\"images/slider.jpg\" height=\"12\" width=\"4\">";
                                                pic += "<img src=\"images/bar.jpg\"  height=\"12\"width=\""+(100-per-mp)*3+"\">";
                                                pic += "<img src=\"images/unused.jpg\" height=\"12\" width=\""+mp*3+"\">";
                                                */
                                               
                                                document.getElementById("-cpuusage").innerHTML = cpu;
                                                document.getElementById("memorypic").innerHTML = pic;
                                                document.getElementById("sused").innerHTML = sused;
                                                document.getElementById("stotal").innerHTML = stotal;
                                                document.getElementById("total").innerHTML = total;
                                                document.getElementById("used").innerHTML = used;
                                                //if (div_isediting!=true)
                                                //        document.getElementById("memdiv").value = per;                                                
                                      }
                                      catch (e){}  
                              }
                              else
                              {
                                loop="none";
                              }
                        }
                }
                else if (loop=="reboot")
                {
                        reboottext = "Initializing Network"; //503
                }
        }
}

//called when xmlhttprequest result arrives, parses the SOAP result
function processReqChange() 
{ 
        try
        {
                var tmp = req.readyState;
                if (tmp == 4)
                        tmp = req.status;
        }
        catch (e)
        {
                //showerror("Unable to connect to device");
        }
        
        if (req.readyState == 4) 
        {
                // only if "OK"
                if (req.status == 200)
                {
                        var currentmethod;                        
                        try
                        {
                                response = req.responseXML.documentElement; //XML data returned from server
                                currentmethod = response.getElementsByTagName("*")[1].tagName;
                                currentmethod = currentmethod.substring(2,currentmethod.length-8);
                        }
                        catch (e)
                        {
                                if (showdebug) document.getElementById("debug").innerHTML += e + "<br>"; 
                        }

                        if (showdebug) document.getElementById("debug").innerHTML += success + ") cr:" + currentmethod + " l:" + loop + " la:" +lastaction + " aq:" + addquery + "<br>";
                        
                        try //check if there was an error in the request
                        {
                                errortext = response.getElementsByTagName('faultstring')[0].firstChild.data;
                                try
                                {
                                    errorcode = response.getElementsByTagName('errorcode')[0].firstChild.data;
                                }
                                catch (e){errorcode="-";}
                                
                                showerror(errortext + " ("+errorcode+")");
                                return;
                        }
                        catch (e)
                        {
                               errorcode=0;
                        }  
                                           
                        if (errorcode==0)
                        {                               
                                try
                                {
                                        error = response.getElementsByTagName("Error")[0].firstChild.data;
                                }
                                catch(e){error="";}                                
                                                                                               
                                if (lastaction=="MiscGetPrintView")
                                {
                                     try
                                     {
                                             var text, skip;
                                             
                                             skip=false; 
                                             
                                             try
                                             {          
                                                text = response.getElementsByTagName("Text")[0].firstChild.data;
                                             }
                                             catch (e)
                                             {
                                                skip = true;
                                                alert("You have to select 1 option at least.")
                                             }
                                             if (!skip)
                                             {
                                                     print_popup(text);
                                             }
                                     }
                                     catch (e){}
                                     
                                     
                                }
                                else if (currentmethod=="PlcGetGroupEnum" && lastaction == "PlcGetSymbols")
                                {                                      
                                        currenttemp = new Array();
                                        try
                                        {
                                                plcxml = load_xml(response.getElementsByTagName("XML")[0].firstChild.data);
                                        }
                                        catch(e){}
                                        try
                                        {
                                                var i = 0;
                                                while (currentgroup = plcxml.getElementsByTagName("Name")[i].firstChild.data)
                                                {
                                                        currenttemp[i] = currentgroup;
                                                        i++;                                                       
                                                }
                                        }
                                        catch(e){}                                       
                                }
                                else if (currentmethod=="PlcGetSymbols")
                                {
                                        if (error.length>0)
                                        {
                                                document.getElementById("CurrentSymbol").innerHTML = error;
                                                return;
                                        }
                                        var i = 0;
                                        var parent = ""
                                        try
                                        {  
                                                response.normalize();
                                                xmlstring = response.getElementsByTagName("XML")[0].firstChild.data;
                                                response = load_xml(xmlstring);
                                                                               
                                                parent = response.getElementsByTagName("Parent")[0].firstChild.data;
                                        }
                                        catch (e)
                                        {}
                                        
                                        if (currenttemp==null)
                                        {
                                                window.setTimeout("query(\"PlcGetGroupEnum\", \"\", \"\");",500);
                                        }
                                                                                                                          
                                        try
                                        {
                                                var symboltable = "<table class=\"menutable\">";
                                                if (parent!="")
                                                {
                                                        var pos1, pos2, pos;
                                                        pos1 = parent.lastIndexOf("[")
                                                        pos2 = parent.lastIndexOf(".")
                                                        
                                                        if (pos1>pos2)
                                                                pos = pos1;
                                                        else pos = pos2;
                                                        
                                                        if (pos == -1)
                                                                parent2 = "";
                                                        else
                                                        {
                                                                parent2 = parent.substring(0,pos);
                                                        }
                                                        if (parent2.charAt(parent2.length-1)==".")
                                                        {
                                                                parent2 = parent2.substring(0,parent2.length-1);
                                                        }
                                                        symboltable += "<tr><td width=\"100%\" align=\"left\" valign=\"middle\"><table class=\"menutable\"><tr><td><img alt=\"\" border=\"0\" src=\"images/OZ.gif\"></td><td><a href=\"javascript:symbolchange('"+parent2+"','')\">..</a></td></td></tr></table></tr>";
                                                }
                                                var symbol = "";
                                                var amount = response.getElementsByTagName("Name").length;
                                                if (amount==0)
                                                {
                                                        symboltable += "</td></tr><tr><td colspan=\"2\"><table><tr>";
                                                        symboltable += "<tr><td><b>Value:</b></td><td id=\"plcvalue_"+parent+"\"></td></tr>";
                                                        symboltable += "<tr><td><b>Type:</b></td><td id=\"plctype_"+parent+"\"></td></tr></table></td></tr>";
                                                        var tmp = new Array();
                                                        tmp[0] = parent;
                                                        plcread(tmp);
                                                        symboltable += "<tr><td colspan=\"2\"><br>Add symbol to favorites:<br>";
                                                        try
                                                        {
                                                                len = currenttemp.length;
                                                        }
                                                        catch (e)
                                                        {
                                                                len = 0;  
                                                        }
                                                        if (len==0)
                                                        {
                                                                len = 1;
                                                                currenttemp = new Array();
                                                                currenttemp[0] = "Default";
                                                        }
                                                        symboltable += "<table>";
                                                        for (i=0; i<len; i++)
                                                        {
                                                                symboltable += "<tr><td><img src=\"images/addfav.gif\"></td><td><a href=\"Javascript:two_arg_query('PlcAddFav','Path','"+parent+"','Group','"+currenttemp[i]+"')\">"+currenttemp[i]+"</a></td></tr>";         
                                                        }
                                                        symboltable += "</table>";
                                                        
                                                        
                                                }
                                                        
                                                for (i=0;i<amount;i++)
                                                {       
                                                        symbol = response.getElementsByTagName("Name")[i].firstChild.data;
                                                        
                                                        pos = symbol.lastIndexOf(".")
                                                        if (pos != -1 && pos!=0)
                                                        {
                                                                symbol2 = symbol.substring(pos+1,symbol.length);
                                                        }
                                                        else symbol2=symbol;
                                                        
                                                        symboltable += "<tr><td valign=\"middle\"><table class=\"menutable\"><tr><td><img alt=\"\" border=\"0\" src=\"images/OZ.gif\"></td><td><a href=\"javascript:symbolchange('"+symbol2+"','"+parent+"')\">"+symbol2+"</a></td></tr></table></td></tr>";
                                                }
                                                symboltable += "</table>";
                                                document.getElementById("CurrentSymbol").innerHTML = symboltable;
                                                if (parent=="")
                                                        document.getElementById("ParentSymbol").innerHTML = "Select a PLC";
                                                else
                                                {
                                                        var icon;
                                                        if (amount==0)
                                                                icon = "SE";
                                                        else icon = "OZ"; 
                                                        document.getElementById("ParentSymbol").innerHTML = "<table class=\"menutable\"><tr><td><img alt=\"\" border=\"0\" src=\"images/"+icon+".gif\"></td><td>"+parent+"</td></tr></table>";
                                                }
                                                
                                        }
                                        catch (e){} 
                                }
                                else if (currentmethod=="MiscGetSubFolders")
                                {                                     
                                        var i = 0;
                                        var parent = ""
                                        try
                                        {  
                                                xmlstring = response.getElementsByTagName("XML")[0].firstChild.data;
                                                response = load_xml(xmlstring);                                     
                                                parent = response.getElementsByTagName("Parent")[0].firstChild.data;
                                        }
                                        catch (e)
                                        {}
                                                                                   
                                        try
                                        {
                                                var foldertable = "<table class=\"menutable\">";
                                                if (parent!="")
                                                {
                                                        if (parent.charAt(0)=="\\")
                                                                parent = parent.substring(1,parent.length);                                                
                                                        var parent2="";
                                                        var pos = parent.lastIndexOf("\\")
                                                        if (pos==parent.length-1)
                                                        {
                                                                parent = parent.substring(0,pos);
                                                                pos = parent.lastIndexOf("\\")
                                                        }
                                                        if (pos == -1)
                                                                parent2 = "";
                                                        else
                                                        {
                                                                parent2 = parent.substring(0,pos);
                                                        }
                                                        parent2 = double_slashes(parent2);
                                                        foldertable += "<tr><td width=\"19\"><img alt=\"\" border=\"0\" src=\"images/OZ.gif\"></td><td width=\"100%\" align=\"left\" valign=\"middle\"><a href=\"javascript:folderchange('"+parent2+"','')\">..</a></td></tr>";
                                                }
                                                var folder = "";
                                                var amount = response.getElementsByTagName("Folder").length;
                                                if (amount==0)
                                                        foldertable += "<tr><td colspan=\"2\">no subfolders</td></tr>";
                                                        
                                                
                                                for (i=0;i<amount;i++)
                                                {       
                                                        parent = double_slashes(parent);
                                                        folder = response.getElementsByTagName("Folder")[i].firstChild.data;
                                                        foldertable += "<tr><td width=\"19\"><img alt=\"\" border=\"0\" src=\"images/OZ.gif\"></td><td valign=\"middle\"><a href=\"javascript:folderchange('"+folder+"','"+parent+"')\">"+folder+"</a></td></tr>";
                                                }
                                                foldertable += "</table>";
                                                document.getElementById("subfolders").innerHTML = foldertable;
                                                
                                        }
                                        catch (e){}                                                  
                                }
                                else if (lastaction=="TcGetLog")
                                {
                                     var text = "";
                                     var notext = true;
                                     if (error.length>0)
                                     {
                                        text += error;
                                        if (error=="Logfile is not Enabled.")
                                        {
                                                text += "<br><a href=\""+fixLink("index.htm#TcGetSettings")+"\">Enable Logfile</a>"
                                        }
                                     }
                                     else
                                     {
                                             
                                             try //use RegEx instead of XML parser to avoid firefox bug
                                             {
                                                var result = req.responseText.match( new RegExp("<Text>([^.]+?)</Text>" ) );
                                                text = result[1];
                                                text = text.replace(/(\r\n|[\r\n])/g, "<br />"); 
                                                notext = false;
                                             }
                                             catch (e)
                                             {
                                                text = "";
                                             }
                                             if (text == "")
                                                text = "Logfile is empty.";
                                             
                                     }
                                     if (document.getElementById("-logtext").innerHTML=="loading...")
                                     {
                                        if (!notext)
                                        {
                                                document.getElementById("-logtext").innerHTML = "Logfile is Enabled.<br><br><input class=\"button\" type=\"submit\" onclick=\"TcLog()\" id=\"apply\" name=\"apply\" value=\"Show\"><br><br>";
                                        }
                                        else document.getElementById("-logtext").innerHTML = text;
                                        //document.getElementById("-logtext").innerHTML += text; do not show content but call this function to know if logfile is enabled
                                     }
                                     else //print view
                                     {
                                             print_popup(text);
                                     }    
                                }
                                else if (lastaction=="MiscShowPages")
                                {
                                        var hideras = false;
                                        var hidesmb = false;
                                        try
                                        {
                                                hideras = response.getElementsByTagName("RAS")[0].firstChild.data;
                                                hidesmb = response.getElementsByTagName("SMB")[0].firstChild.data;
                                        }
                                        catch (e){}
                                        
                                        if (hideras==1)
                                        {
                                                document.getElementById("hideras").style.display="";
                                        }
                                        if (hidesmb==1)
                                        {
                                                document.getElementById("hidesmb").style.display="";
                                        }
                                        load_page("DeviceName");
                                }
                                else if (lastaction=="DeviceName")
                                {
                                        try
                                        {
                                                device_name = response.getElementsByTagName("DeviceName")[0].firstChild.data;
                                                document.getElementById("devicenametitle").innerHTML = device_name;
                                                document.getElementById("devicenametitle").style.fontWeight = "normal";
                                                document.title = device_name;
                                        }
                                        catch (e)
                                        {
                                            type="Overview"; 
                                            showerror("Unable to get Devicename");   
                                        }
                                        complete_init();
                                }
                                else if (currentmethod=="TimeZoneEnum")
                                {
                                        var i = 0;
                                        var currentzone = "";
                                        currenttemp = new Array();
                                        try
                                        {
                                                zonexml = load_xml(response.getElementsByTagName("XML")[0].firstChild.data);
                                        }
                                        catch(e){showerror("Unable to load Timezones")}
                                        try
                                        {
                                                while (currentzone = zonexml.getElementsByTagName("Name")[i].firstChild.data)
                                                {
                                                        if (i==document.getElementById("TimeZone").firstChild.innerHTML)
                                                                document.getElementById("TimeZone").firstChild.innerHTML = currentzone;
                                                        currenttemp[i] = currentzone;
                                                        i++;                                                       
                                                }
                                        }
                                        catch(e){}
                                        lastaction = "TimeGetSettings";
                                }
                                else if (currentmethod=="TimeGetSettings")
                                {
                                        var temp = response;
                                        try
                                        {
                                                req.onreadystatechange = function () {};
                                                req.abort();
                                        }
                                        catch (e){}
                                        
                                        lastaction = "TimeZoneEnum";
                                        window.setTimeout("query('TimeZoneEnum');", 100);
                                        init_show();
                                        TimeGetSettings();
                                        show(temp);
                                }
                                else if (currentmethod!="SysSetMemDivision" && currentmethod!="MiscRestore" && currentmethod!="MiscReboot") //get device name and complete init
                                {
                                        init_show();
                                        eval(lastaction+"();");
                                        if (error!="")
                                        {
                                                add_text(error, "red");
                                                triggersavealert = false; //do not ask for reboot on errors
                                        }
                                        else
                                        {
                                                if (pageaddtext!="")
                                                        add_text(pageaddtext, "green");
                                        }
                                        show(response);
                                }
                                else if (currentmethod=="SysSetMemDivision")
                                {
                                        if (error!="")
                                        {
                                               document.getElementById("infoadd").innerHTML = error; 
                                        }
                                        else document.getElementById("infoadd").innerHTML = "";
                                } 
                                success++;                    
                        }                       
                        
                }
                else 
                {
                        if (loop=="none")
                                showerror("Unable to connect to device"); //cannot retrieve xml data
                        if (showdebug)
                                document.getElementById("debug").innerHTML += "XMLHTTP error: "+req.statusText+" ("+lastaction+") ("+req.status+")";
                }
        }
}

function show(response)
{
        document.getElementById("contenttable").style.height = '150px';
        reset_open();
        var text="";
        var hiddenfields="";
        var rowcount=0;
        var addoneargquery="";

        if (type=="Overview")
        {
               text+="<img src=\"images/cx1000.jpg\"><br>";                                                      
               text+="<h2 align=\"left\">"+device_name+" Configuration</h2>";
               text+="<p align=\"left\">The CX series covers the whole range of Beckhoff control technology both in terms of price and performance: The product range is designed for tasks requiring the characteristics and computing capacity of Industrial PCs, but whose budget does not stretch to full-blown Industrial PCs. The system only uses those components that are actually required. For example, a CX device can be operated in headless mode, i.e. without display or keyboard; in this case, the associated interface is not required. While the resulting control system has no visualisation, it does have communications capability via the built-in Ethernet and RS232 interfaces.<br><br>If local visualisation is required, this can be implemented via a DVI (digital video interface), to which all Beckhoff Control Panels and all commercially available monitors with DVI input or VGA input can be connected. The touch screen signal is read via one of the two available USB interfaces.<br><br><a href=\""+fixLink("index.htm#Print")+"\">Print Settings</a></p>";
               text+="<br><br><br><p align=\"center\" valign=\"bottom\" class=\"smallfont\">CxConfig Webpage "+version+"</p>";
               type="text";               
        }
        else if (type=="FactorySettings")
        {
               text+="<h2 align=\"center\"><font color=red>Restore Factory-Defaults of "+device_name+"?</font></h2><br>";
               text+="<p align=\"center\"><input class=\"button\" type=\"submit\" onclick=\"doReset(true)\" value=\"restore settings\"></p>";
               type="text";      
        }
        else if (type=="ReloadNeeded")
        {
               text+="<h2 align=\"center\">"+device_name+" has been reset</h2><br>";
               text+="<p align=\"center\">You have to reload this page after the device restarted.</p>";
               type="text";
        }
        else if (type=="Reboot")
        {
               text+="<h2 align=\"center\">Reboot "+device_name+"?</h2><br>";
               text+="<p align=\"center\"><input class=\"button\" type=\"submit\" onclick=\"doReboot(false,true)\" value=\"reboot\"></p>";
               type="text";      
        }
        else if (type=="ListSymbols")
        {
                text+="<h2 align=\"left\">PLC Symbols</h2><br><br><table width=95%><td><b><div id=\"ParentSymbol\"></div></b><br><div id=\"CurrentSymbol\"></div></td></tr></table>";
               	type="text";
               	one_arg_query("PlcGetSymbols", "Path", "");
        }
        else if (type=="Software")
        {
                text+="<p align=\"center\"><b>Not implemented yet</b></p>";
               	type="text";
        }
        else if ((type.indexOf("CustomerPage")==0))
        {
                customerpage = type.substring(12,type.length);
                if (customerpagetitle[customerpage]!="")
                        text+="<p align=\"center\"><h2>"+customerpagetitle[customerpage]+"</h2></p>";
                text+="<iframe width=\"100%\" frameborder=\"0\" height=\""+(screen.availHeight-350)+"\" id='customerpageframe' name='customerpageframe' src='"+customerpages[customerpage]+"'></iframe>";
                type="text";
        }
        else if (type=="TcLog")
        {
            text+="<p align=\"center\"><h2>TwinCAT Logfile</h2></p>";
            text+="<p align=\"left\" id=\"-logtext\">loading...</p>";
            type="text";
            TcLog();
        }
        else if (type=="Print")
        {
            text+="<p align=\"center\"><h2>Print Settings</h2></p>";
            text+="<table class=\"datatable\"  cellSpacing=\"1\" cellPadding=\"1\" align=\"center\" width=\"80%\">";
            text+="<tr><td align=\"center\" class=toptable width=33%>Enabled</td><td class=toptable>Name</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowSystem\" checked=\"checked\"></td><td class=normaltable>System Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowNetwork\" checked=\"checked\"></td><td class=normaltable>Network Adapter</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowFiles\" checked=\"checked\"></td><td class=normaltable>File Versions<br>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowDisplay\" checked=\"checked\"></td><td class=normaltable>Display Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowTime\" checked=\"checked\"></td><td class=normaltable>Time Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowMisc\" checked=\"checked\"></td><td class=normaltable>Misc Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowCustomer\" checked=\"checked\"></td><td class=normaltable>Customer Options</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowUser\" checked=\"checked\"></td><td class=normaltable>User Information</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowRas\" checked=\"checked\"></td><td class=normaltable>RAS Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowFtp\" checked=\"checked\"></td><td class=normaltable>FTP Server Settings</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowTwinCat\" checked=\"checked\"></td><td class=normaltable>TwinCAT Options</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowShares\" checked=\"checked\"></td><td class=normaltable>Shares</td></tr>";
            text+="<tr><td align=\"center\" class=normaltable><input type=\"checkbox\" id=\"ShowFirewall\" checked=\"checked\"></td><td class=normaltable>Firewall Settings</td></tr>";
            text+="<tr><td align=\"center\" class=titletable><input type=\"checkbox\" id=\"SelAll\" checked=\"checked\" onclick=\"print_selectall()\"></td><td class=titletable>All/None</td></tr>";
            text+="<tr><td align=\"center\" class=lockedtable colspan=\"2\"><input class=\"button\" type=\"submit\" onclick=\"printpreview()\" id=\"apply\" name=\"apply\" value=\"Show\"></td></tr>";
            text+="</table>";
            type="text";
        }
        else if ((type=="selectbox" || type=="table") && showcontent)
        {
                var xmlstring;
                try
                {
                        xmlstring = response.getElementsByTagName('XML')[0].firstChild.data;
                }
                catch (e)
                {
                        
                        text+="<p align=\"center\"><b>"+addtext[addtext.length-1]+"</b></p>";
                        remove_text(addtext.length-1);
                        
                       	type="text";
                       	
                       	if (lastaction == "TcRouteEnum")
                       	{
                                extramethods = "TcAddRoute";
                                extramethoddisplay = "Add Route";
                                extramethodinput += get_addtable();
                       	}
                }
                if (type!="text")
                {
                        response = load_xml(xmlstring);
                
                        try
                        {
                                if (type=="selectbox")
                                        text="<select name=\"sel\" id=\"sel\" onchange=\"one_arg_query('"+listoptions.func+"','"+listoptions.view+"',this.value)\">";
                                else
                                {
                                        text="<table class=\"datatable\" cellSpacing=\"1\" cellPadding=\"3\" width=\"90%\" align=\"center\" border=\"0\"><tr>";
                                        for (var i = 0; i < params.length; i++)
                                        {
                                                if (params[i].disp!="")
                                                           text+="<td class=\"toptable\">"+params[i].disp+"</td>";
                                        }
                                        for (var i = 0; i < editmethod.length; i++) 
                                        {
                                                if (editmethod[i].type == "checkbox")
                                                        text+="<td class=\"toptable\">"+editmethod[i].display+"</td>";
                                                else text+="<td class=\"toptable\">&nbsp;</td>"; 
                                        }
                                        text+="</tr>";
                                }        
                                node = true;
        
                                var firstdata; 
                                var rowcount = 0;
                                while (node)
                                {
                                        try
                                        {
                                                node = response.getElementsByTagName(params[0].name)[rowcount];
                                                firstdata = node.firstChild.data;
                                        }
                                        catch (e){break;}
                                        
                                        if (type=="selectbox")
                                        {
                                                var selected = "";
                                                if (rowcount==0)
                                                {
                                                        selected = " selected";
                                                        addquery = "one_arg_query(\""+listoptions.func+"\",\""+listoptions.view+"\",\""+response.getElementsByTagName(listoptions.arg)[0].firstChild.data+"\")";
                                                }
                                                text+="<option value=\""+response.getElementsByTagName(listoptions.arg)[rowcount].firstChild.data+"\""+selected+">"+node.firstChild.data+"</option>";
                                        }
                                        else //type=="table"
                                        {
                                                text+="<tr><td class=normaltable>";
                                                if (lastaction=="DispModeEnum")
                                                {
                                                        if (response.getElementsByTagName(params[2].name)[rowcount].firstChild.data=="1")
                                                                text+= "[ <span class=\"menu\">"+firstdata+"</span> ]";   
                                                        else text+= "<a href=\"javascript:change_disp_mode('"+rowcount+"')\">"+firstdata+"</a>";
                                                }
                                                else text+=firstdata;
                                                if (lastaction=="PlcGetGroup")
                                                        text+="<br><span class=\"smallfont\" id=\"plctype_"+firstdata+"\">";
                                                
                                                text+="</td>";
                                                for (var i = 1; i < params.length; i++)
                                                {
                                                        if (params[i].disp!="")
                                                        {
                                                                try
                                                                {
                                                                        if (lastaction=="PlcGetGroup")
                                                                        {
                                                                                value = firstdata;
                                                                                text+="<td height=\"24\" width=\"30%\" class=normaltable onclick=\"plc_start_edit('"+value+"')\"><span id=\"plcvalue_"+value+"\"></span><span id=\"plcedit_"+value+"\"></span></td>";
                                                                                text+="<td align=\"center\" class=normaltable><input class=\"button\" type=\"submit\" onclick=\"two_arg_query('PlcRemoveFav','Path','"+value+"','Group','"+document.getElementById("sel").value+"')\" value=\"Remove\"></td>";
                                                                                editmethod = new Array();
                                                                                if (rowcount==0)
                                                                                        currenttemp = new Array();
                                                                                currenttemp[rowcount] = value;
                                                                                break;
                                                                        }
                                                                        else
                                                                        {
                                                                                value = response.getElementsByTagName(params[i].name)[rowcount].firstChild.data;
                                                                                if (params[i].type)
                                                                                {
                                                                                        value = format(params[i].type, value);
                                                                                }
                                                                                text+="<td height=\"24\" class=normaltable>"+value+"</td>";
                                                                        }
                                                                }
                                                                catch (e){text+="<td class=normaltable></td>";}
                                                        }
                                                }
                                                for (var i = 0; i < editmethod.length; i++) 
                                                {
                                                        var value1 = i;
                                                        var value2 = "";
                                                        if (editmethod[i].variable1)
                                                                value1 = response.getElementsByTagName(editmethod[i].variable1)[rowcount].firstChild.data;
                                                        if (editmethod[i].variable2)
                                                        {
                                                                if (editmethod[i].type=="password")    
                                                                        value2 = editmethod[i].variable2;
                                                                else if (editmethod[i].variable2=="")
                                                                        value2 = "";
                                                                else value2 = response.getElementsByTagName(editmethod[i].variable2)[rowcount].firstChild.data;
                                                        }
                                                                        
                                                        text+="<td class=normaltable><p align=\"center\">";
                                                        if (editmethod[i].type=="checkbox")
                                                        {
                                                                var checked="";
                                                                if (value2=="1")
                                                                {
                                                                        checked="checked";
                                                                }
                                                                text+="<input type=\"checkbox\" onclick=\"two_arg_query('"+editmethod[i].func+"','"+editmethod[i].field1+"','"+value1+"','"+editmethod[i].field2+"',this.checked) \" id=\""+editmethod[i].func+"\" name=\""+editmethod[i].func+"\" "+checked+"></p></td>";
                                                        }
                                                        else if (editmethod[i].type=="password")
                                                        {
                                                                text+="<input class=\"button\" type=\"submit\" onclick=\"input_query('"+editmethod[i].func+"','"+editmethod[i].field1+"','"+value2+"',true,'"+value1+"','"+editmethod[i].field2+"')\" id=\""+editmethod[i].func+"\" name=\""+editmethod[i].func+"\" value=\""+editmethod[i].display+"\">";
                                                        }
                                                        else
                                                        {
                                                                if (editmethod[i].type == "enable")
                                                                {
                                                                        if (is_true(value2))
                                                                        {
                                                                                value2 = 0;
                                                                                editmethod[i].display = "Disable";
                                                                        }
                                                                        else
                                                                        {
                                                                                value2 = 1;
                                                                                editmethod[i].display = "Enable";
                                                                        }
                                                                }
                                                                text+="<input class=\"button\" type=\"submit\" onclick=\"";
                                                                if (editmethod[i].field2!="")
                                                                        text+="two_arg_query('"+editmethod[i].func+"','"+editmethod[i].field1+"','"+value1+"', '"+editmethod[i].field2+"','"+value2+"')";
                                                                else text+="one_arg_query('"+editmethod[i].func+"','"+editmethod[i].field1+"','"+value1+"')";
                                                                
                                                                text+="\" id=\""+editmethod[i].func+"\" name=\""+editmethod[i].func+"\" value=\""+editmethod[i].display+"\">";
                                                        }
                                                        text+="</p></td>";
                                                }
                                                text+="</tr>";
                                        }                       
                                        rowcount++;
                                }
                                if (type=="selectbox")
                                        text += "</select>";
                                else text += "</table>";
                        }
                        catch (e)
                        {
                                if (showdebug) document.getElementById("debug").innerHTML += e+"<br>";
                                showerror(e)
                        };    
                }  
        }
        else if (showcontent)
        {
                for (var i=0; i<params.length; i++)
                {
                        try
                        {
                                try
                                {
                                        value = response.getElementsByTagName(params[i].name)[0].firstChild.data;
                                }
                                catch (e){value=""}
                                                              
                                if (params[i].type)
                                {
                                        value = format(params[i].type, value);
                                }
                                var editable = true;
                                var hidden = false;
                                if (params[i].lock)
                                {
                                        if (params[i].lock.indexOf("show:")==0)
                                        {
                                                hidden = true;
                                                try
                                                {
                                                        value2 = response.getElementsByTagName(params[i].lock.substring(5,params[i].lock.length))[0].firstChild.data;
                                                }
                                                catch (e){value2=""}
                                                if (is_true(value2))
                                                        hidden = false;
                                        }
                                        else if (params[i].lock.indexOf("locked:")==0)
                                        {
                                                try
                                                {
                                                        value2 = response.getElementsByTagName(params[i].lock.substring(7,params[i].lock.length))[0].firstChild.data;
                                                }
                                                catch (e){value2=""}
                                                if (is_true(value2))
                                                {
                                                        editable = false;
                                                }
                                        }
                                        else if (params[i].lock=="locked" || params[i].lock=="subroute")
                                        {
                                                editable = false;
                                        }
                                }
                                if (params[i].disp!="" && !hidden)
                                {
                                        if (value=="")
                                                value="<i>-</i>";
                                        text+="<tr><td height=\"24\" class=\"titletable\" width=\"33%\"><table width=\"100%\"><td>"+params[i].disp+"</td><td align=\"right\"><image title=\"Use the apply button to accept changes\" id=\""+params[i].name+"info\" style=\"display:none;\" src=\"images/info.gif\" alt=\"changed\"></td></tr></table></td><td id=\""+params[i].name+"td\" class=\""+((editable)?"normaltable":"lockedtable")+"\">";

                                        if (extramethods!="" && editable)
                                        {
                                                var image = "";
                                                if (params[i].type=="Folder")
                                                        image = "OZ";
                                                else if (params[i].type=="Date")
                                                        image = "Calendar";
                                                else if (params[i].type=="Time")
                                                        image = "Time";
                                                if (image !="")
                                                        text+="<table class=\"menutable\"><tr><td valign=\"top\" width=\"19\"><img alt=\"\" border=\"0\" src=\"images/"+image+".gif\"></td><td width=\"100%\" valign=\"middle\">";

                                                text+="<input type=\"hidden\" value=\""+value+"\" id=\""+params[i].name+"old\"><span style=\"width:100%; display: block;\" id=\""+params[i].name+"\"><span style=\"width:90%; display: block;\" onclick=\"edit('"+i+"',this.innerHTML)\">"+value+"</span></span>";
                                                if (image!="")
                                                        text+="</td></tr></table>";
                                        }
                                        else text+= "<span style=\"width:100%; display: block;\" "+(params[i].lock.indexOf("locked:")==0 ? "id=\""+params[i].name+"\"" : "" )+"><span "+(params[i].lock=="subroute" ? "id=\""+params[i].name+"\"" : "")+" style=\"width:100%; display: block;\">"+value+"</span></span>";
                                                
                                        text+="</td></tr>";
                                        if (params[rowcount].space==true)
                                        {
                                                text+="<tr><td height=\"24\" class=lockedtable>&nbsp;</td><td class=lockedtable>&nbsp;</td></tr>";
                                                rowcount++;
                                        }
                                        rowcount++;
                                }
                                else hiddenfields+="<input type=\"hidden\" name=\""+params[i].name+"\" id=\""+params[i].name+"\" value=\""+value+"\">";
                                
                        }
                        catch (e){};
                }
        } 

        if (showcontent)
        {     
                document.getElementById("add").innerHTML = "";       
                
                var addto="main";
                var html="<table cellSpacing=\"0\" cellPadding=\"0\" border=\"0\"><tr><td valign=\"top\" width=\"570\" class=\"normaltable\" style=\"background:#FFFFFF\">";
                if (title!="")
                        html+="<h2>"+title+"</h2>";
                if (doadd)
                {
                        addto="add";
                }
                
                if (lastaction=="NicEnum")
                {
                       var value="";
                       try
                       {
                                if (is_true(response.getElementsByTagName("IpRouting")[0].firstChild.data))
                                        value = "Enabled";
                                else value = "Disabled";
                       }
                       catch (e) {}
                       html += "<table class=\"datatable\" cellSpacing=\"1\" cellPadding=\"1\" width=\"90%\" align=\"center\" border=\"0\"><td class=normaltable width=33%>"+text+"</td><td class=normaltable>";
                       html += "IP Routing: <input class=\"input\" readonly=\"readonly\" type=\"text\" id=\"IPRouting\" value=\""+value+"\"><input class=\"button\" type=\"submit\" onclick=\"switch_iprouting()\" id=\"switch\" name=\"switch\" value=\"Switch\">";
                       html += "</td></tr></table>";
                }
                else if (type=="selectbox")
                {
                        html += "<table class=\"datatable\" cellSpacing=\"1\" cellPadding=\"1\" width=\"90%\" align=\"center\" border=\"0\"><td class=normaltable width=33%>"+text+"</td></tr></table>";
                }
                else if (type=="table")
                {
                        html += "<p>"+text+"</p>";
                }
                else if (type=="text")
                {
                        html += text;
                }
                else
                {
                        html += "<table class=\"datatable\" cellSpacing=\"1\" cellPadding=\"1\" width=\"90%\" align=\"center\" border=\"0\"><tr><td class=toptable width=33%>Name</td><td class=toptable>Value</td></tr>"+text+"</table>"+hiddenfields;
                }
                if (extramethods!="")
                {                  
                        var applybutton = "<p align=\"center\"><input "+(extramethoddisplay=="Apply"? "class=\"button_disabled\"":"class=\"button\"")+" type=\"submit\" onclick=\"apply()\" id=\"apply\" name=\"apply\" value=\""+extramethoddisplay+"\" "+(extramethoddisplay=="Apply"? "DISABLED":"" )+"></p>";
                        html+="<p align=\"center\">";
                        if (extramethoddisplay=="Apply")
                              html+=applybutton+extramethodinput;
                        else html+=extramethodinput+applybutton;
                        html+="</p>";                        
                }
                                
                document.getElementById(addto).innerHTML = html+"</td></tr></table>";
                
                if (lastaction=="FwGetRule")
                        if (is_true(response.getElementsByTagName("Active")[0].firstChild.data))
                                document.getElementById("fwenable").value="Disable";
        }
        for (var i=0; i<addtext.length; i++)
        {
                document.getElementById("add").innerHTML += "<p style=\"font-size: 9pt;\"><font color=\""+addtextcolor[i]+"\">"+addtext[i]+"</font></p>";
        }     
                 
        document.getElementById("info").innerHTML = addinfo;
       
        
        if (triggersavealert)
                rebootWithQuestion("Settings saved."); 
        
        if (addquery!="")
        {
                increase_text();

                addquery = replace(addquery, "\\", "\\\\");
                try
                {
                        window.setTimeout(addquery, 0);
                }
                catch (e) {}   
        }
}
 
function showerror (text)
{
    errors++;
    document.getElementById("add").innerHTML = ""; 
    document.getElementById("info").innerHTML = "";
    document.getElementById("infoadd").innerHTML = "";
    document.getElementById("main").innerHTML = "<p align=\"center\"><span class=\"error\">"+text+"</span></p>";   
}


